#!/usr/local/bin/perl
#################################################
# MeySoft Banner Manager - Version 2.5F
# Last Update: June 8, 1998
# Copyright (c) 1998 MeySoft
# Author: Jeffrey L. Meyer, Sr.Programmer
# WebMaster@MeySoft.com
#
# THIS HEADER MUST REMAIN INTACT
##############################################
require "config25.pl";
require "bm25fn.pl";
alarm(60);

@slist=split(/,/,$CFG{'slist'});
$ext_msg=" ";
$ext_msg2="";
$no_error=1;
$sponsor=0;
@CTRL=();
#######################################################
if($ENV{'REQUEST_METHOD'} eq 'POST'){
   read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
}else{
 $data="$ENV{'QUERY_STRING'}";
}
@targets=();
@blocks=();

@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);

   $field_val=~ s/\+/ /g;
   $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
   if($field_name eq 'targets'){
     push(@targets,$field_val);
   }
   if($field_name eq 'blocks'){
     push(@blocks,$field_val);
   }

   $field_val=~ s/\,/./g;
   $field_val=~ s/\&//g;
   $field_val=~ s/\"//g;
   $field_val=~ s/\'//g;
   $field_val=~ s/\`//g;
   $field_val=~ s/\*//g;
   $field_val=~ s/\\//g;
   $field_val=~ s/<!--(.|\n)*-->//g;
   $field_val=~ s/<([^>]|\n)*>//g;

 $DATA{$field_name}=$field_val;
}

if(($data eq 'FORM')||($data eq '')||($data eq 'SPONSORFORM')){
 &send_header("Banner Submission"); 
 
if($data eq 'SPONSORFORM'){
 $sponsor=1;
 $style="$CFG{'sponsor_style'}";
 $DATA{'style'}="$CFG{'sponsor_style'}";
 $DATA{'account'}="sponsor";
}else{
 $DATA{'style'}="400x40";
 $style="400x40";
$DATA{'account'}="swap";
}
 &send_form;
 exit;
}

$debug=0;

if($DATA{'style'}){
 $style="$DATA{'style'}";
}else{
  $no_error=0;
  $ext_msg .="Style not selected,";
  &send_form;
 if($debug==0){
  exit;
 }
}
$kc=&style_index($style);

$dbp="$CFG{'acct_dir'}/$style";
&get_date;

&get_ctrl_data("$dbp");
if($CTRL[3] != 9999){
 &rescan("$dbp");
}

$tst="$style";
if($tst =~ /S/){
 chop($tst);
}
($bw,$bh)=split(/x/,$tst);
$no_error=1;
if(($style =~ /S/)||($DATA{'account'} eq 'sponsor')){
 $sponsor=1;
}
############################################
if(!($DATA{'name'})){
 $ext_msg .="Name missing, ";
 $no_error=0;
}

if(!($DATA{'password'})){
 $ext_msg .="Missing password, ";
 $no_error=0;
}

if((!($DATA{'verify'}))||($DATA{'verify'} ne $DATA{'password'})){
 $no_error=0;
 $ext_msg .= "Verified password does not match, please re-enter,<BR>";
}

if(!($DATA{'email'}=~ /.*\@.*\..*/)){ 
   $ext_msg .="Invalid or Missing Email, ";
   $no_error=0;
}

if(!($DATA{'linkurl'}=~ /.*tp:\/\/.*\..*/)){
     $ext_msg .="Invalid or Missing LinkURL, ";
     $no_error=0;
}

if($CFG{'use_upload'} == 0){
if(!($DATA{'bannerurl'}=~ /.*tp:\/\/.*\..*/)){ 
   $ext_msg .="Invalid or Missing Banner URL, ";
    $no_error=0;
 $ban=0;
}else{
 $ban=1;
}
}

if(!($DATA{'sitetype'})){
 $site="N/A";
}else{
 $site="$DATA{'sitetype'}";
}

$blks=@blocks;
if($blks == 0){
 push(@blocks,"NONE");
}

#########################################################
if(($DATA{'create'})&&($no_error==1)){
 $dt="$data";
  print "Location: submitb.cgi?$dt\n\n";
  exit;
}

&send_header("Banner Submission");
&bad_boy;
&send_form;
&end;

#########################
sub send_error {
# print "Content-type: text/plain\n\n";
 print "Could not create $dbp/$acct_num\n";
 print "Error; $!\n";
exit;
}
#######################################
sub send_form{
print <<"WEB_FORM";
<FORM METHOD="POST" ACTION="submit.cgi">
<center>
<table border=0 bgcolor="#$COLOR{'headers'}" cellpadding=5 cellspacing=0 WIDTH=600>
<TD ALIGN=middle>
<FONT SIZE=4 COLOR="#$COLOR{'header_text'}">
WEB_FORM

if($sponsor==0){
 print "Banner Ad Submission Form - Step 1";

}else{
 print "Sponsor Ad Submission Form - Step 1";
}
print <<"WEB_FORM";
</font>
</TD>
</TABLE>
<B>ALL Fields on this form are required.</B><BR>
Make any needed changes here. When you are sure all <BR>
information is correct, press 'Continue...' .
<P>
WEB_FORM

if($no_error==0){
print <<"WEB_FORM";
<table width=600 border=1>
<tr><td align=middle><font color="#$COLOR{'link'}">$ext_msg</font></td>
</tr></table>
<BR>
WEB_FORM
}

print <<"WEB_FORM";
<table width=600 border=0 bgcolor="#$COLOR{'table_bgcolor'}" cellpadding=5 cellspacing=0>
<tr>
<TD colspan=2 bgcolor="#$COLOR{'headers'}" ALIGN=middle><FONT SIZE=4 COLOR="#$COLOR{'header_text'}">Your Site Information</FONT></TD>
</tr>
<tr><td align=right>Site Name</td><td align=left><INPUT TYPE="text" NAME="name" value="$DATA{'name'}" SIZE=40 MAXLENGTH=60></td>
</tr>
<tr><td align=right>Email Address</td><td align=left><INPUT TYPE="text" NAME="email" value="$DATA{'email'}" SIZE=40 MAXLENGTH=100></td>
</tr>
<BR>
WEB_FORM

if($CFG{'use_upload'} == 0){
print "<tr><td align=right>Banner Image URL</td><td align=left><INPUT TYPE=\"text\" NAME=\"bannerurl\" value=\"$DATA{'bannerurl'}\" SIZE=40 MAXLENGTH=100>";

if($ban==1){
print "<BR><img src=\"$CFG{'images'}/$bw.gif\"><br clear=all><img src=\"$DATA{'bannerurl'}\" border=1 ALT=\"Your Banner Image\">";
print "<img src=\"$CFG{'images'}/$bh.gif\"><br clear=all><I>Your banner should appear above</I>";
}
}
print "</td></tr><tr><td align=right>Link URL</td><td align=left> <INPUT TYPE=\"text\" NAME=\"linkurl\" value=\"$DATA{'linkurl'}\" SIZE=40 MAXLENGTH=100></td></tr><BR>";
print "<input type=\"hidden\" name=\"pageurl\" value=\"N/A\">\n";


print <<"WEB_FORMM";
</table>
<BR>

WEB_FORMM

if($DATA{'account'} eq 'sponsor'){
  print "<input type=\"hidden\" name=\"account\" value=\"sponsor\">";
}else{
print <<"PAGE";
<table border=0 bgcolor="#$COLOR{'table_bgcolor'}" cellpadding=5 cellspacing=0 WIDTH=600>
<TR>
<TD colspan=2 bgcolor="#$COLOR{'headers'}" ALIGN=middle><FONT SIZE=4 COLOR="#$COLOR{'header_text'}">Your Account Type</FONT></TD>
</tr>
PAGE
print "<tr><td align=right><b>Account Type:</b></td><td align=left>";
if($DATA{'account'} eq 'swap'){
  print "<input checked type=\"radio\" name=\"account\" value=\"swap\">Swap";
}else{
  print "<input type=\"radio\" name=\"account\" value=\"swap\">Swap";
}
if($DATA{'account'} eq 'paid'){
  print "<input checked type=\"radio\" name=\"account\" value=\"paid\">Paid";
}else{
  print "<input type=\"radio\" name=\"account\" value=\"paid\">Paid";
}
if($DATA{'account'} eq 'click'){
  print "<input checked type=\"radio\" name=\"account\" value=\"click\">Click-thru";
}else{
  print "<input type=\"radio\" name=\"account\" value=\"click\">Click-thru";
}
}
print <<"WEB_FORMM";
</td></tr>
WEB_FORMM

if($DATA{'style'} eq $CFG{'sponsor_style'}){
 print "<input type=hidden name=style value=$CFG{'sponsor_style'}>";
}else{
print "<tr><td align=right><B>Style:</b></td><td align=left>";

if($DATA{'style'} eq '400x40'){
 print "<INPUT checked TYPE=\"radio\" NAME=\"style\" VALUE=\"400x40\">400x40 pixels ";
 print "<INPUT TYPE=\"radio\" NAME=\"style\" VALUE=\"468x60\">468x60 pixels";
}
if($DATA{'style'} eq '468x60'){
 print "<INPUT TYPE=\"radio\" NAME=\"style\" VALUE=\"400x40\">400x40 pixels";
 print "<INPUT checked TYPE=\"radio\" NAME=\"style\" VALUE=\"468x60\">468x60 pixels";
}
}
print "</td></tr></table><BR>";
###########
# CATEGORY

if(($CFG{'use_targeting'}==1)&&($sponsor == 0)){
 print "<table border=0 bgcolor=\"#$COLOR{'table_bgcolor'}\" cellpadding=5 cellspacing=0 WIDTH=600>";
 print "<TR><TD colspan=2 bgcolor=\"#$COLOR{'headers'}\" ALIGN=middle><FONT SIZE=4 COLOR=\"#$COLOR{'header_text'}\">Your Target Advertising</FONT></TD></tr>";

 print "<tr><td align=right><B>Select a single site category <BR>that best describes your site content</B><BR></td>";
 print "<td align=left><SELECT NAME=\"sitetype\" SIZE=1>\n";
 $site=~ s/\n//g; 
 open(LST,"category.txt");
 while($line=<LST>){
  $line=~ s/\n//g;
  if("$line" eq "$site"){
     print "<OPTION SELECTED>$line\n";
  }else{
     print "<OPTION>$line\n";
  }
 }
 close(LST);
 print "</SELECT></td></tr>\n";
}else{
 print "<input type=hidden name=sitetype value=\"N/A\">\n";
}
############
# TARGETS

if(($CFG{'use_targeting'}==1)&&($sponsor == 0)){
 print "<tr><td align=right><B>Select the site categories <BR>that you wish to <I>target</i> your ad to</B><BR>";
 print "<I>(Use CTRL to select/deselect<BR> multiple categories)</i></td>";
 print "<td align=left><SELECT MULTIPLE NAME=\"targets\" SIZE=5>\n";
 open(LST,"category.txt");
 while($line=<LST>){
  $line=~ s/\n//g;
  $in_list=0;
    foreach $targ(@targets){
      $targ=~ s/\n//g;
        if("$line" eq "$targ"){
          $in_list=1;
        }
    }
  if($in_list==1){
     print "<OPTION SELECTED>$line\n";
  }else{
     print "<OPTION>$line\n";
  }
 }
 close(LST);
 print "</SELECT></td></tr>\n";
}else{
 print "<input type=hidden name=targets value=\"ALL\">\n";
}
############
###########
# BLOCKS

if(($CFG{'use_targeting'}==1)&&($sponsor == 0)){
 print "<tr><td align=right><B>Select the site categories that<BR> you do not want to show ads for</B><BR>";
 print "<I>(Use CTRL to select/deselect<BR> multiple categories)</i></td>";
 print "<td align=left><SELECT MULTIPLE NAME=\"blocks\" SIZE=5>\n";
 open(LST,"category.txt");
 while($line=<LST>){
  $line=~ s/\n//g;
  $in_list=0;
    foreach $block(@blocks){
      $block=~ s/\n//g;
        if("$line" eq "$block"){
          $in_list=1;
        }
    }
  if($in_list==1){
     print "<OPTION SELECTED>$line\n";
  }else{
     print "<OPTION>$line\n";
  }
 }
 close(LST);
 print "</SELECT></td></tr></table><BR>";
}else{
 print "<input type=hidden name=blocks value=\"NONE\">";
}
############
print <<"WEB_FORMM";
<table border=0 bgcolor="#$COLOR{'table_bgcolor'}" cellpadding=5 cellspacing=0 WIDTH=600>
<tr>
<TD colspan=2 bgcolor="#$COLOR{'headers'}" ALIGN=middle><FONT SIZE=4 COLOR="#$COLOR{'header_text'}">Your Password Selection</FONT></TD>
</tr>
<tr><td align=right><B>Select a password</B></td>
<td align=left><INPUT TYPE="password" NAME="password" value=\"$DATA{'password'}\" SIZE=20 MAXLENGTH=20> 20 characters max</td>
</tr>
<tr><td align=right><B>Verify password</B></td>
<td align=left><INPUT TYPE="password" NAME="verify" value=\"$DATA{'verify'}\" SIZE=20 MAXLENGTH=20></td>
</tr>
</table>
<CENTER>
<hr size=2>
WEB_FORMM
if($no_error==1){
 print "<input type=hidden name=\"create\" value=\"create\">";
 print "<INPUT TYPE=\"image\" src=\"$CFG{'images'}/cont.gif\" alt=\"Continue...\">";
}else{
 print "<INPUT TYPE=\"image\" src=\"$CFG{'images'}/update.gif\" alt=\"Update Profile\">";
}

print <<"WEB_FORMM";
</CENTER>
</FORM>
<CENTER>
<a href="$CFG{'banner_page'}"><img src="$CFG{'images'}/mainpage.gif" alt="Back to Banner Page"></a>
</CENTER>

</center>
</BODY></HTML>
WEB_FORMM
exit;
}

####################
sub bad_boy{
$bad_boy=0;
if(!(-e "badboys.dat")){
 open(NEW,">badboys.dat")||&send_error;
 print NEW "noone\@nowhere.com";
 close(NEW);
}
open(BB,"badboys.dat")||&send_error;
while($boy=<BB>){
 push(@badboys,$boy);
}
close(BB);
$his_addr="$ENV{'REMOTE_HOST'}";
$her_addr="$ENV{'REMOTE_ADDR'}";

if($DATA{'email'} ne ''){
 $that_guy="$DATA{'email'}";
}else{
 $that_guy='nobody@domain.com';
}
if($DATA{'linkurl'} ne ''){
  $ano_guy="$DATA{'linkurl'}";
}else{
 $ano_guy='http://www.nowhere.com';
}
if($DATA{'name'} ne ''){
 $his_name="$DATA{'name'}";
}else{
 $his_name="John Doe";
}

foreach $guy(@badboys){
chop $guy;
 if(($his_addr eq $guy)||
    ($her_addr eq $guy)||
    ($his_name eq $guy)||
    ($that_guy eq $guy)||
    ($ano_guy eq $guy)){
 $bad_guy="$guy";
  $bad_boy=1;
  }
}
$items="$his_addr $her_addr $his_name $that_guy $ano_guy matches a bad item in our lockout list ($bad_guy)";
$items=~ s/ /+/g;
if($bad_boy==1){
 print "Location: sorry.cgi?$items\n\n";
}
}
